// module: Tableau2.java
// auteur: felipe
// objet:  quelques details supplementaires sur les tableaux
// comment: lors d'un passage d'un tableau en parametre, l'adresse du tableau est passe par valeur
//          mais on peut acceder depuis cette adresse aux elements et le modifier

public class Tableau2 {

    // une methode qui prend un tableau en argument et qui le modifie
    static void addOneToTable(int t[]) { // passage par reference
	for (int i=0; i<t.length; i++) t[i] = t[i] + 1;
    }

    // une methode qui affiche un tableau
    static void afficheTable(String message, int [] t) {
	System.out.print(message);
	for (int i=0; i<t.length; i++) 
	    System.out.print(" " + t[i]);
	System.out.println(""); // pour le retour charriot
    } 

    // la methode principale
    public static void main(String[] args) {

	// une autre facon d'initialiser un tableau par un new implicite
	int table [] = {1,2,3,4,5,6,7,8,10};

	// traitement sur la table initialisee
	afficheTable("Avant " , table);
	addOneToTable(table);
	afficheTable("Apres " , table);
    }
}




