// module: TableauN.java
// auteur: felipe
// objet:  les tableaux a N dimensions
// comment: un element d'un tableau peut a son tour etre un tableau
//          => dimension N

public class TableauN {

    // pour changer un peu , on declare le tableau comme variable membre
    // pour le moment on dit juste que table est un tableau de tableaux
    // et qu'il contient 3 elts

    static int table [][] = new int [3][];
    
    // la methode principale
    public static void main(String[] args) {
	// faisons un tableau dont:
	// la premiere ligne (representation mentale) contient 5 elts
	// la seconde ligne contient 4 elts
	// et la troisieme ligne contient 2 elts

	table[0] = new int [5];
	table[1] = new int [4];
	table[2] = new int [2];

	// pour le moment il y a des o dans tous les elts.
	System.out.println("Ligne 1: " + table[0].length + " elts");
	System.out.println("Ligne 2: " + table[1].length + " elts");
	System.out.println("Ligne 3: " + table[2].length + " elts");

	// on peut ensuite le remplir "a la mitaine..."
	table[0][0] = 1;
	table[0][1] = 2; // etc...
	// attention: table[2][2] serait une erreur car table[2] est une table de 2 elts 

	// la meme version en utilisant les new implicites
	// deja plus simple non ?
	int table2[][] = {
	    {1,2,3,4,5},
	    {1,2,3,4},
	    {1,2}
	};
	System.out.println("Ligne 1: " + table2[0].length + " elts");
	System.out.println("Ligne 2: " + table2[1].length + " elts");
	System.out.println("Ligne 3: " + table2[2].length + " elts");
	System.out.println("nombre de lignes : " + table2.length);

	// cela dit , ca n'est pas vraiment tres utile.
	// ce qui est montre ici peut etre etendu a la dimension N
	
	// en pratique on a rarement besoin de plus qu'une matrice 
	// ici de deux lignes (de 0 a 1) et 5 colonnes (de 0 a 4)
	int matrice [][] = new int [2][5];
    }
}

