/**
   Auteur: Mohamed Lokbani

   cet exemple prsente l'utilisation des variables
   statiques.

   avant cela voir le fichier chpstatic.java

   dans cet exemple, ce n'est pas parce que
   la variable est statique et initialise que
   nous n'avons pas le droit de modifier sa valeur.

   
*/


class Test {

    // champs ...
    static String message = "Hello World!";

    // constructeur ...
    public Test(String monmessage) {
	message = monmessage;
    }
    // mthodes ...
    public static void main(String[] args) {
	System.out.println(message); // affiche: HelloWorld!

	// constructeur, la variable message va prdre sa nouvelle valeur
	Test x = new Test("toto");

	System.out.println(message); // affiche: toto
    }
}
