/**
   Auteur: Mohamed Lokbani

   cet exemple prsente l'utilisation des champs
   statiques.

    chaque fois que nous crons un compte, on aimerait
   incrmenter une variable qui permet de garder une trace
   du nombre de comptes crs.

   puisque cette variable devra tre partage par tous les objets
   elle sera donc unique. Donc elle devra tre ratache  la
   classe et non pas les objets. Pour ce faire nous avons
   besoin de la dclarer statiques. Ainsi elle sera visible
   de tous les objets crs.
   
*/

class compte{
    // Dfinition des champs
    String nom;
    double actif;
    int limite; // limite de crdit

    // varable statique initialise  0
    static int nbcomptes=0;

    // Dfinition des mthodes

    public compte(String monnom,double monactif,int malimite){
	nom = monnom ;
	actif = monactif ;
	limite = malimite ;
	//  chaque fois qu'un compte est cr, on incrmente
	// nbcomptes.
	nbcomptes++;
    }
    public compte copie(){
	compte X = new compte(nom,actif,limite);
	return X;
    }

    double depot(double argent){
	actif += argent;
	return actif;
    }
    void affiche() {
	System.out.println("nom de la personne: " + nom);
	System.out.println("actif de son compte: " + actif);
	System.out.println("limite de crdit: " + limite);

    }
}

public class chpstatic {

    public static void main(String [] args){

	// nbcompte peut tre appele directement, pas besoin
	// donc d'avoir un objet pour pouvoir le faire.
	System.out.println("nbcomptes: " + compte.nbcomptes);
	compte a = new compte("toto",99,5000);
	// on peut quand mme y accder via l'objet a
	System.out.println("nbcomptes: " + a.nbcomptes);
	compte b = new compte("tutu",55,2000);
	// ... ou l'objet b
	System.out.println("nbcomptes: " + b.nbcomptes);

	// mais il est conseill d'y accder en utilisant
	// le nom de la classe, car la variable est plus ratache
	//  la classe qu' un objet en particulier.
	System.out.println("nbcomptes: " + compte.nbcomptes);

	a.depot(50);
	a.affiche();
    }
}
